<template>
    <form @submit.prevent="submitForm">
        <div class="space-y-8 py-4">
            <div class="border-b border-gray-900/10 pb-12">
                <h2 class="text-base font-semibold leading-7 text-gray-900">Add Property </h2>
                <div class="mt-10 grid grid-cols-1 gap-x-6 gap-y-8 sm:grid-cols-6">
                    <div class="sm:col-span-3">
                        <label for="first-name" class="block text-sm font-medium leading-6 text-gray-900">
                            Enter county
                        </label>
                        <div class="mt-2">
                            <input
                            required 
                            type="text" 
                            name="county" 
                            v-model="propertyFormData.county"
                            id="county" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Enter Number of bedrooms
                        </label>
                        <div class="mt-2">
                            <input
                            required 
                            type="number" 
                            name="num_bedrooms" 
                            v-model="propertyFormData.num_bedrooms"
                            id="num_bedrooms" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Enter Number of bathrooms
                        </label>
                        <div class="mt-2">
                            <input
                            required 
                            type="number" 
                            v-model="propertyFormData.num_bathrooms"
                            name="num_bathrooms" 
                            id="num_bathrooms" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Enter price
                        </label>
                        <div class="mt-2">
                            <input
                            required 
                            type="number" 
                            v-model="propertyFormData.price"
                            name="price" 
                            id="price" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <!-- need to map the data -->
                    <div class="sm:col-span-3">
                        <label for="property_type_id" class="block text-sm font-medium leading-6 text-gray-900">
                            Choose Property type
                        </label>
                        <div class="mt-2">
                            <select 
                            id="property_type_id" 
                            name="property_type_id"  
                            v-model="propertyFormData.property_type_id"
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                                <option v-for="propertyType in propertyTypeList" :key="propertyType.id" :value="propertyType.id">
                                    {{ propertyType.title }}
                                </option>
                            </select>
                        </div>
                    </div>
                    
                    <div class="sm:col-span-3">
                        <legend class="text-sm text-gray-900">Type</legend>
                        <div class="mt-2 space-y-2">
                            <div class="flex items-center gap-x-3">
                                <input
                                required 
                                id="sale" 
                                name="type" 
                                v-model="propertyFormData.type" 
                                type="radio" 
                                value="sale"
                                class="h-4 w-4 border-gray-300 text-indigo-600 focus:ring-indigo-600" />
                                <label for="sale" class="block text-sm font-medium leading-6 text-gray-900">Sale</label>
                            </div>
                            <div class="flex items-center gap-x-3">
                                <input
                                required 
                                id="rent" 
                                name="type" 
                                type="radio" 
                                value="rent"
                                v-model="propertyFormData.type" 
                                class="h-4 w-4 border-gray-300 text-indigo-600 focus:ring-indigo-600" />
                                <label for="rent" class="block text-sm font-medium leading-6 text-gray-900">Rent</label>
                            </div>
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="about" class="block text-sm font-medium leading-6 text-gray-900">
                            Decsription
                        </label>
                            <div class="mt-2">
                                <textarea 
                                id="about" 
                                name="discription" 
                                v-model="propertyFormData.description"
                                rows="2" 
                                class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                            </div>
                    </div>
                </div>
            </div>
            <div class="pb-6">
                <h2 class="text-base font-semibold leading-7 text-gray-900">Address </h2>
                <div class="mt-10 grid grid-cols-1 gap-x-6 gap-y-8 sm:grid-cols-6">
                    <div class="sm:col-span-2">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                          Country
                        </label>
                        <div class="mt-2">
                            <input
                            required 
                            type="text" 
                            name="country" 
                            v-model="propertyFormData.country"
                            id="country" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>

                    <div class="sm:col-span-2">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Town
                        </label>
                        <div class="mt-2">
                            <input
                            required 
                            type="text" 
                            name="town" 
                            v-model="propertyFormData.town"
                            id="town" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>

                    <div class="sm:col-span-2">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                            ZIP / Postal code
                        </label>
                        <div class="mt-2">
                            <input
                             
                            type="text" 
                            name="post_code" 
                            v-model="propertyFormData.post_code"
                            id="post_code" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="col-span-full">
                        <label for="about" class="block text-sm font-medium leading-6 text-gray-900">
                            Enter Address
                        </label>
                            <div class="mt-2">
                                <textarea 
                                id="about" 
                                name="address"
                                v-model="propertyFormData.address"
                                rows="2" 
                                class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                            </div>
                    </div>
                    <div class="col-span-full">
                        <label for="cover-photo" class="block text-sm font-medium leading-6 text-gray-900">
                            Upload Image
                        </label>
                        <div class="mt-2 flex justify-center rounded-lg border border-dashed border-gray-900/25 px-6 py-10">
                            <div class="text-center">
                                <input
                                required 
                                        id="image_full" 
                                        name="image_full" 
                                        type="file" 
                                        @change="handlePropertyImageUpload"
                                        />
                               
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="mt-6 flex items-center justify-end gap-x-6 pb-12">
            <button type="button" class="text-sm font-semibold leading-6 text-gray-900">Cancel</button>
            <button type="submit"
                class="rounded-md bg-indigo-600 px-3 py-2 text-sm font-semibold text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600">Save</button>
        </div>
    </form>
</template>
  
<script setup>
 import { onMounted } from 'vue';
 import { usePropertyStore } from '../stores/property';
 const propertyStore = usePropertyStore();
 const propertyTypeList = ref([]);

 const propertyFormData = ref({
    county: ref(''),
    num_bedrooms: ref(''),
    num_bathrooms: ref(''),
    price: ref(''),
    property_type_id: ref(''),
    description: ref(''),
    address: ref(''),
    image_full: ref(null),
    type: ref(''),
    country: ref(''),
    town: ref(''),
    post_code: ref(''),
 })

 const getPropertyType = async () => {
    await propertyStore.getPropertyTypes();
    propertyTypeList.value = propertyStore.propertyTypes;
}

const handlePropertyImageUpload = (e) =>{
    const file = e.target.files[0];
    propertyFormData.value.image_full = file;
}
const submitForm = async () =>{
    const newFormData = new FormData();
    newFormData.append('county', propertyFormData.value.county);
    newFormData.append('num_bedrooms', propertyFormData.value.num_bedrooms);
    newFormData.append('num_bathrooms', propertyFormData.value.num_bathrooms);
    newFormData.append('price', propertyFormData.value.price);
    newFormData.append('property_type_id', propertyFormData.value.property_type_id);
    newFormData.append('description', propertyFormData.value.description);
    newFormData.append('type', propertyFormData.value.type);
    newFormData.append('address', propertyFormData.value.address);
    newFormData.append('country', propertyFormData.value.country);
    newFormData.append('town', propertyFormData.value.town);
    newFormData.append('post_code', propertyFormData.value.post_code);
    if (propertyFormData.value.image_full) {
        newFormData.append('image_full', propertyFormData.value.image_full);
    }
    await propertyStore.createProperty(newFormData);
    navigateTo('/');

    // console.log(propertyStore.createProperty,errors); 
    // if(propertyStore.createProperty.ok){
    //     alert('Property created successfully');
    //     navigateTo('/');
    // }
}
onMounted(() => {
    getPropertyType();
})

</script>